
  <!DOCTYPE html>
  <html>
    <head>
      <title>CustomizedDot.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/components/Graphic/components/CustomizedDot.tsx</td><td class="">98.43%</td><td class="">80%</td><td class="">127</td><td class="">125</td><td class="">2</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useCallback, useRef } from &#x27;react&#x27;;
import { DOT_CLICK_EVENT, EXCLUDED_COLOR, SELECTED_COLOR } from &#x27;../constants&#x27;;
import s from &#x27;./CustomizedDot.module.scss&#x27;;

export const CustomizedDot = &lt;
  Key extends string = string,
  PayloadKey extends Key &amp; &#x27;id&#x27; = Key &amp; &#x27;id&#x27;,
  Payload extends {
    [key in PayloadKey]: number;
  } &amp; { selected: boolean; excluded?: boolean } = {
    [key in PayloadKey]: number;
  } &amp; { selected: boolean; excluded?: boolean }
&gt;(props: {
  cx: number;
  cy: number;
  fill?: string;
  stroke?: string;
  height: number;
  width: number;
  r: number;
  value: number;
  dataKey: Key;
  xAxisKey: Key;
  payload: Payload;
}) =&gt; {
  const {
    cx,
    cy,
    fill,
    stroke,
    r,
    height,
    width,
    payload,
    xAxisKey,
    value,
    dataKey
  } = props;
  const ref = useRef&lt;SVGCircleElement | null&gt;(null);
  const handleClick = useCallback(
    (event: React.MouseEvent&lt;SVGCircleElement&gt;) =&gt; {
      if (ref.current) {
        ref.current.dispatchEvent(
          new CustomEvent(DOT_CLICK_EVENT, {
            detail: {
              id: (payload as unknown as { id: number }).id,
              dataKey,
              x: (
                payload as {
                  [key in Key]: number;
                }
              )[xAxisKey],
              y: value,
              cx,
              cy
            },
            bubbles: true
          })
        );
        event.stopPropagation();
      }
    },
    [cx, cy, dataKey, payload, value, xAxisKey]
  );
  if (!cx || !cy) return null;

  return (
    &lt;circle
      ref={ref}
      onClick={handleClick}
      cx={cx}
      cy={cy}
      fill={
        payload.selected
          ? SELECTED_COLOR
          : payload.excluded
          ? EXCLUDED_COLOR
          : fill
      }
      height={height}
      width={width}
      r={r}
      stroke={
        payload.selected
          ? SELECTED_COLOR
          : payload.excluded
          ? EXCLUDED_COLOR
          : stroke
      }
      strokeWidth={1}
      className={`recharts-dot recharts-line-dot ${s.CustomizedDot}`}
    /&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/components/Graphic/components/CustomizedDot.tsx&quot;,&quot;line&quot;:45,&quot;character&quot;:19,&quot;text&quot;:&quot;payload as unknown as { id: number }&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/components/Graphic/components/CustomizedDot.tsx&quot;,&quot;line&quot;:48,&quot;character&quot;:16,&quot;text&quot;:&quot;payload as {\n                  [key in Key]: number;\n                }&quot;,&quot;kind&quot;:3}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  